﻿using ModdingUtils;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnboundLib;
using UnboundLib.Cards;
using UnityEngine;


namespace JRC.Cards
{
    class Card_Ragnarok : CustomCard
    {
        public override void SetupCard(CardInfo cardInfo, Gun gun, ApplyCardStats cardStats, CharacterStatModifiers statModifiers, Block block)
        {
            //Edits values on card itself, which are then applied to the player in `ApplyCardStats`
        }
        public override void OnAddCard(Player player, Gun gun, GunAmmo gunAmmo, CharacterData data, HealthHandler health, Gravity gravity, Block block, CharacterStatModifiers characterStats)
        {
            //Edits values on player when card is selected
            foreach (Player otherPlayer in ModdingUtils.Extensions.PlayerStatus.GetOtherPlayers(player))
            {
                otherPlayer.data.stats.health = 1f;
                otherPlayer.data.stats.movementSpeed = 1f;
                otherPlayer.data.stats.jump = 1f;
                otherPlayer.data.stats.gravity = 1f;
                otherPlayer.data.stats.sizeMultiplier = 1f;
                otherPlayer.data.stats.tasteOfBloodSpeed = 1f;
                otherPlayer.data.stats.rageSpeed = 1f;
                otherPlayer.data.stats.attackSpeedMultiplier = 1f;
                otherPlayer.data.stats.regen = 0f;
                otherPlayer.data.stats.lifeSteal = 0f;
                otherPlayer.data.stats.respawns = 0;
                otherPlayer.data.stats.numberOfJumps = 0;
                otherPlayer.data.stats.secondsToTakeDamageOver = 0f;
                otherPlayer.data.stats.fastSlow = 0f;
                otherPlayer.data.stats.slowSlow = 0f;
                otherPlayer.data.stats.slow = 0f;
                otherPlayer.data.stats.refreshOnDamage = false;
                otherPlayer.data.stats.automaticReload = true;
            }
        }
        public override void OnRemoveCard(Player player, Gun gun, GunAmmo gunAmmo, CharacterData data, HealthHandler health, Gravity gravity, Block block, CharacterStatModifiers characterStats)
        {
            //Run when the card is removed from the player
        }


        protected override string GetTitle()
        {
            return "Ragnarok";
        }
        protected override string GetDescription()
        {
            return "Reset all stats on all players.";
        }
        protected override GameObject GetCardArt()
        {
            return null;
        }
        protected override CardInfo.Rarity GetRarity()
        {
            return CardInfo.Rarity.Common;
        }
        protected override CardInfoStat[] GetStats()
        {
            return new CardInfoStat[]
            {
            };
        }
        protected override CardThemeColor.CardThemeColorType GetTheme()
        {
            return CardThemeColor.CardThemeColorType.FirepowerYellow;
        }
        public override string GetModName()
        {
            return JRC.ModInitials;
        }
    }
}
