﻿using BepInEx;
using UnboundLib;
using UnboundLib.Cards;
using JRC.Cards;
using HarmonyLib;
using CardChoiceSpawnUniqueCardPatch.CustomCategories;


namespace JRC
{
    // These are the mods required for our mod to work
    [BepInDependency("com.willis.rounds.unbound", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.moddingutils", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.cardchoicespawnuniquecardpatch", BepInDependency.DependencyFlags.HardDependency)]
    // Declares our mod to Bepin
    [BepInPlugin(ModId, ModName, Version)]
    // The game our mod is associated with
    [BepInProcess("Rounds.exe")]
    public class JRC : BaseUnityPlugin
    {
        private const string ModId = "com.alexsany.rounds.mods.JRC";
        private const string ModName = "Just Random Cards";
        public const string Version = "0.0.0"; // What version are we on (major.minor.patch)?

        public const string ModInitials = "JRC";
        public static JRC instance { get; private set; }



        void Awake()
        {
            // Use this to call any harmony patch files your mod may have
            var harmony = new Harmony(ModId);
            harmony.PatchAll();
        }
        void Start()
        {
            instance = this;

            CustomCard.BuildCard<Card_Pudge>();
            CustomCard.BuildCard<Card_Weakest>();
            CustomCard.BuildCard<Card_TheWorld>();
            CustomCard.BuildCard<Card_SixEyes>();
        }
    }
}
