﻿using ModdingUtils.Extensions;
using ModdingUtils.MonoBehaviours;
using ModdingUtils.Utils;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnboundLib;
using UnboundLib.Cards;
using UnityEngine;

public class BlockDrag : ReversibleEffect
{
    private void OnBlock(BlockTrigger.BlockTriggerType trigger)
    {
        var myPos = player.data.transform.position;

        foreach (Player otherPlayer in ModdingUtils.Extensions.PlayerStatus.GetOtherPlayers(player))
        {
            var otherPos = otherPlayer.data.transform.position;
            var dir = new Vector2(myPos.x - otherPos.x, myPos.y - otherPos.y);
            otherPlayer.data.healthHandler.CallTakeForce(dir * 1000, ForceMode2D.Impulse, true, true, 0);
        }
    }

    public override void OnStart()
    {
        data.block.BlockAction += OnBlock;
    }
}
