﻿using ModdingUtils.Extensions;
using ModdingUtils.MonoBehaviours;
using ModdingUtils.Utils;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnboundLib;
using UnboundLib.Cards;
using UnityEngine;

public class TimeStop : ReversibleEffect
{
    private float cd = 0f;

    private void OnBlock(BlockTrigger.BlockTriggerType trigger)
    {
        if (cd > 0f)
        {
            return;
        }

        foreach (Player otherPlayer in ModdingUtils.Extensions.PlayerStatus.GetOtherPlayers(player))
        {
            otherPlayer.data.stunHandler.AddStun(4f);
            otherPlayer.data.silenceHandler.RPCA_AddSilence(4f);
        }

        cd = 14f;
    }

    public override void OnStart()
    {
        data.block.BlockAction += OnBlock;
    }
    public override void OnUpdate()
    {
        if (cd > 0f)
        {
            cd -= Time.deltaTime;
        }
    }
}
